// This file was generated by Mendix Studio Pro.
//
// WARNING: Only the following code will be retained when actions are regenerated:
// - the import list
// - the code between BEGIN USER CODE and END USER CODE
// - the code between BEGIN EXTRA CODE and END EXTRA CODE
// Other code you write will be lost the next time you deploy the project.
import { Big } from "big.js";
import { NativeModules } from "react-native";

// BEGIN EXTRA CODE
// END EXTRA CODE

/**
 * Displays the specified notification straight away.
 * 
 * Note: It is not possible to display a notification whilst the app is in the foreground on iOS 9.
 * @param {string} body - This field is required.
 * @param {string} title
 * @param {string} subtitle
 * @param {boolean} playSound
 * @param {string} actionName
 * @param {string} actionGuid
 * @returns {Promise.<void>}
 */
export async function DisplayNotification(body, title, subtitle, playSound, actionName, actionGuid) {
	// BEGIN USER CODE
    // Documentation https://rnfirebase.io/docs/v5.x.x/notifications/displaying-notifications
    if (NativeModules && !NativeModules.RNFirebase) {
        return Promise.reject(new Error("Firebase module is not available in your app"));
    }
    // eslint-disable-next-line @typescript-eslint/no-var-requires
    const firebase = require("react-native-firebase");
    if (!body) {
        return Promise.reject(new Error("Input parameter 'Body' is required"));
    }
    const channel = new firebase.notifications.Android.Channel("mendix-local-notifications", "Local notifications", firebase.notifications.Android.Importance.Default);
    await firebase.notifications().android.createChannel(channel);
    const notification = new firebase.notifications.Notification()
        .setBody(body)
        .android.setChannelId("mendix-local-notifications");
    if (title) {
        notification.setTitle(title);
    }
    if (subtitle) {
        notification.setSubtitle(subtitle);
    }
    if (playSound) {
        notification.setSound("default");
    }
    if (actionName || actionGuid) {
        notification.setData({
            actionName,
            guid: actionGuid
        });
    }
    return firebase.notifications().displayNotification(notification);
	// END USER CODE
}
